"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class EvidenceSet(ProtocolElement):
    """
    An evidences set contains all the evidences and curations for a
    variant or group of variants. It also links to all reports for the
    variant/s. The curations are stored in an array of CurationEntry
    that keep a history of changes to curation status. A curation must
    be associated to a phenotype and optionally to a mode of
    inheritance (MOI) and a genomic feature, only one curation per
    combination of phenotype, MOI and genomic feature is stored. The
    evidences are stored in an array of EvidenceEntry. An evidence may
    be optionally associated to a phenotype, mode of inheritance and
    genomic feature. An evidence not associated to any phenotype is
    considered to be an evidence for any phenotype. Evidence
    consistency is evaluated based on existing curations.  Every
    EvidenceSet is uniquely identified by:  * variants identifiers
    (being a variant identifier formed by chromosome + position +
    reference + alternate) after    natural text sorting  Duplication
    of the prior fields is not be supported.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "userId",
        "variants",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import cva as cva_1_0_0
        from protocols.protocol_6_1 import opencb as opencb_1_3_0

        return {
            "comments": cva_1_0_0.Comment,
            "curations": cva_1_0_0.CurationEntry,
            "evidences": opencb_1_3_0.EvidenceEntry,
            "reportEvents": cva_1_0_0.ReportEventEntry,
            "variants": cva_1_0_0.Variant,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import cva as cva_1_0_0
        from protocols.protocol_6_1 import opencb as opencb_1_3_0

        return {
            "org.gel.models.cva.avro.Comment": cva_1_0_0.Comment,
            "org.gel.models.cva.avro.CurationEntry": cva_1_0_0.CurationEntry,
            "org.opencb.biodata.models.variant.avro.EvidenceEntry": opencb_1_3_0.EvidenceEntry,
            "org.gel.models.cva.avro.ReportEventEntry": cva_1_0_0.ReportEventEntry,
            "org.gel.models.cva.avro.Variant": cva_1_0_0.Variant,
            "org.gel.models.cva.avro.EvidenceSet": cva_1_0_0.EvidenceSet,
        }

    __slots__ = [
        "userId",
        "variants",
        "comments",
        "curations",
        "evidences",
        "reportEvents",
    ]

    def __init__(
        self,
        userId,
        variants,
        comments=list,
        curations=list,
        evidences=list,
        reportEvents=list,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_0_0.EvidenceSet model.

        :param userId:
            The author of the curation event
        :type userId: str
        :param variants:
            OpenCB variant model containing the basic variant coordinates and
            annotations from CellBase.         Sample information like
            studies and genotypes is removed.
        :type variants: list[Variant]
        :param comments:
            Comments for this variant
        :type comments: list[Comment]
        :param curations:
            The list of curations for different phenotypes for a known variant
        :type curations: list[CurationEntry]
        :param evidences:
            The list of evidences for this variant
        :type evidences: list[EvidenceEntry]
        :param reportEvents:
            Report events
        :type reportEvents: list[ReportEventEntry]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.0.0"
